#include <TinyGPS++.h>
#include <SoftwareSerial.h>
/*
   This sample sketch demonstrates the normal use of a TinyGPS++ (TinyGPSPlus) object.
   It requires the use of SoftwareSerial, and assumes that you have a
   4800-baud serial GPS device hooked up on pins 4(rx) and 3(tx).
*/
static const int RXPin = 5, TXPin = 4;
static const uint32_t GPSBaud = 9600;

// The TinyGPS++ object
TinyGPSPlus gps;

// The serial connection to the GPS device
SoftwareSerial ss(RXPin, TXPin);
//const int TimeZone = +5; 
void setup()
{
  Serial.begin(9600);
  ss.begin(GPSBaud);

//  Serial.println(F("DeviceExample.ino"));
//  Serial.println(F("A simple demonstration of TinyGPS++ with an attached GPS module"));
//  Serial.print(F("Testing TinyGPS++ library v. ")); Serial.println(TinyGPSPlus::libraryVersion());
//  Serial.println(F("by Mikal Hart And Developed for Indian time +5:30"));
//  Serial.println();
}

void loop()
{
  // This sketch displays information every time a new sentence is correctly encoded.
  while (ss.available() > 0)
    if (gps.encode(ss.read()))
     displayInfo();

  if (millis() > 5000 && gps.charsProcessed() < 10)
  {
    Serial.println(F("No GPS detected: check wiring."));
    while(true);
  }
}
void displayInfo()// showing display to serial
{
//delay(100);
//  Serial.print(F(" "));
  if (gps.time.isValid())
  {
   int hr= (gps.time.hour()+5);
   if(hr >12)
   {
    hr-=12;
   }

   
   int mn= (gps.time.minute()+30);
   if(mn>59)
   {
    mn -=60;
   }
  
   int sec= (gps.time.second());
   // display ////////////////////////////////////////////////
    if (hr < 9) Serial.print(F("0"));
    if(gps.time.minute()>29 ) Serial.print (hr+=1); 
   else 
   {
   Serial.print (hr);
   }
   
    Serial.print(F(":"));
    if (mn < 10) Serial.print(F("0"));
    Serial.print(mn);
   
    Serial.print(F("\n"));
  }
  else
  {
  //  Serial.print(F("INVALID"));
  }

 // Serial.println();
  delay(500);
}
